=== modified file 'NEWS'
--- NEWS	2008-12-03 16:40:38 +0000
+++ NEWS	2008-12-04 11:50:30 +0000
@@ -26,6 +26,9 @@
     * Preserve transport decorators while following redirections.
       (Vincent Ladeuil, #245964)
 
+    * Provides a finer and more robust filter for accepted redirections.
+      (Vincent Ladeuil, #303959, #265070)
+
     * ``Transport.readv()`` defaults to not reading more than 100MB in a
       single array. Further ``RemoteTransport.readv`` sets this to 5MB to
       work better with how it splits its requests.

=== modified file 'bzrlib/tests/test_http.py'
--- bzrlib/tests/test_http.py	2008-12-04 11:25:56 +0000
+++ bzrlib/tests/test_http.py	2008-12-04 11:50:30 +0000
@@ -1756,6 +1756,18 @@
         # Both transports share the some connection
         self.assertEquals(t._get_connection(), r._get_connection())
 
+    def test_redirected_to_self_with_slash(self):
+        t = self._transport('http://www.example.com/foo')
+        e = errors.RedirectRequested('http://www.example.com/foo',
+                                     'http://www.example.com/foo/',
+                                     self._qualified_prefix)
+        r = t._redirected_to(e)
+        self.assertIsInstance(r, type(t))
+        # Both transports share the some connection (one can argue that we
+        # should return the exact same transport here, but that seems
+        # overkill).
+        self.assertEquals(t._get_connection(), r._get_connection())
+
     def test_redirected_to_host(self):
         t = self._transport('http://www.example.com/foo')
         e = errors.RedirectRequested('http://www.example.com/foo',

